wl_keyboard_listener Struct Reference
The wl_keyboard interface

`#include <wayland-client-protocol.h>`

## Data Fields

void(* | keymap )(void *data, struct wl_keyboard *wl_keyboard, uint32_t format, int32_t fd, uint32_t size)
void(* | enter )(void *data, struct wl_keyboard *wl_keyboard, uint32_t serial, struct wl_surface *surface, struct wl_array *keys)
void(* | leave )(void *data, struct wl_keyboard *wl_keyboard, uint32_t serial, struct wl_surface *surface)
void(* | key )(void *data, struct wl_keyboard *wl_keyboard, uint32_t serial, uint32_t time, uint32_t key, uint32_t state)
void(* | modifiers )(void *data, struct wl_keyboard *wl_keyboard, uint32_t serial, uint32_t mods_depressed, uint32_t mods_latched, uint32_t mods_locked, uint32_t group)
void(* | repeat_info )(void *data, struct wl_keyboard *wl_keyboard, int32_t rate, int32_t delay)

## Detailed Description

Definition at line 4510 of file wayland-client-protocol.h.

## Field Documentation

## enter

void(* wl_keyboard_listener::enter) (void *data, struct wl_keyboard *wl_keyboard, uint32_t serial, struct wl_surface *surface, struct wl_array *keys)

enter event

Notification that this seat's keyboard focus is on a certain surface.

Parameters

  serial | serial number of the enter event
  surface | surface gaining keyboard focus
  keys | the currently pressed keys

Definition at line 4534 of file wayland-client-protocol.h.

## key

void(* wl_keyboard_listener::key) (void *data, struct wl_keyboard *wl_keyboard, uint32_t serial, uint32_t time, uint32_t key, uint32_t state)

key event

A key was pressed or released. The time argument is a timestamp with millisecond granularity, with an undefined base.

Parameters

  serial | serial number of the key event
  time | timestamp with millisecond granularity
  key | key that produced the event
  state | physical state of the key

Definition at line 4564 of file wayland-client-protocol.h.

## keymap

void(* wl_keyboard_listener::keymap) (void *data, struct wl_keyboard *wl_keyboard, uint32_t format, int32_t fd, uint32_t size)

keyboard mapping

This event provides a file descriptor to the client which can be memory-mapped to provide a keyboard mapping description.

Parameters

  format | keymap format
  fd | keymap file descriptor
  size | keymap size, in bytes

Definition at line 4520 of file wayland-client-protocol.h.

## leave

void(* wl_keyboard_listener::leave) (void *data, struct wl_keyboard *wl_keyboard, uint32_t serial, struct wl_surface *surface)

leave event

Notification that this seat's keyboard focus is no longer on a certain surface.

The leave notification is sent before the enter notification for the new focus.

Parameters

  serial | serial number of the leave event
  surface | surface that lost keyboard focus

Definition at line 4550 of file wayland-client-protocol.h.

## modifiers

void(* wl_keyboard_listener::modifiers) (void *data, struct wl_keyboard *wl_keyboard, uint32_t serial, uint32_t mods_depressed, uint32_t mods_latched, uint32_t mods_locked, uint32_t group)

modifier and group state

Notifies clients that the modifier and/or group state has changed, and it should update its local state.

Parameters

  serial | serial number of the modifiers event
  mods_depressed | depressed modifiers
  mods_latched | latched modifiers
  mods_locked | locked modifiers
  group | keyboard layout

Definition at line 4581 of file wayland-client-protocol.h.

## repeat_info

void(* wl_keyboard_listener::repeat_info) (void *data, struct wl_keyboard *wl_keyboard, int32_t rate, int32_t delay)

repeat rate and delay

Informs the client about the keyboard's repeat rate and delay.

This event is sent as soon as the wl_keyboard object has been created, and is guaranteed to be received by the client before any key press event.

Negative values for either rate or delay are illegal. A rate of zero will disable any repeating (regardless of the value of delay).

This event can be sent later on as well with a new value if necessary, so clients should continue listening for the event past the creation of wl_keyboard.

Parameters

  rate | the rate of repeating keys in characters per second
  delay | delay in milliseconds since key down until repeating starts

Since
  4

Definition at line 4608 of file wayland-client-protocol.h.

The documentation for this struct was generated from the following file:

- gen/wayland-client-protocol.h